SChannel Class Reference

`#include <tlsschannel.h>`

Inheritance diagram for SChannel:
[legend]

## Public Member Functions

| SChannel (TLSHandler *th, const std::string &server)
virtual | ~SChannel ()
virtual bool | init (const std::string &=EmptyString, const std::string &=EmptyString, const StringList &=StringList())
virtual bool | encrypt (const std::string &data)
virtual int | decrypt (const std::string &data)
virtual void | cleanup ()
virtual bool | handshake ()
virtual bool | hasChannelBinding () const
virtual const std::string | channelBinding () const
virtual void | setCACerts (const StringList &cacerts)
virtual void | setClientCert (const std::string &clientKey, const std::string &clientCerts)
Public Member Functions inherited from TLSBase
| TLSBase (TLSHandler *th, const std::string server)
virtual | ~TLSBase ()
void | setInitLib (bool init)
virtual bool | isSecure () const
virtual const std::string | channelBindingType () const
virtual const CertInfo & | fetchTLSInfo () const

## Detailed Description

This class implements a TLS backend using SChannel.

Author
  Jakob Schröter js@ca.nosp@m.maya.nosp@m..net

Since
  0.9

Definition at line 38 of file tlsschannel.h.

## Constructor & Destructor Documentation

## SChannel()

SChannel | ( | TLSHandler * | th,
|  | const std::string & | server )

Constructor.

Parameters

  th | The TLSHandler to handle TLS-related events.
  server | The server to use in certificate verification.

Definition at line 21 of file tlsschannel.cpp.

## ~SChannel()

~SChannel | ( |  | ) |

virtual

Virtual destructor.

Definition at line 27 of file tlsschannel.cpp.

## Member Function Documentation

## channelBinding()

const std::string channelBinding | ( |  | ) | const

virtual

Returns the channel binding data for the established connection.

Returns
  The channel binding data, if any, or the empty string.

Reimplemented from TLSBase.

Definition at line 490 of file tlsschannel.cpp.

## cleanup()

void cleanup | ( |  | ) |

virtual

This function performs internal cleanup and will be called after a failed handshake attempt.

Implements TLSBase.

Definition at line 247 of file tlsschannel.cpp.

## decrypt()

int decrypt | ( | const std::string & | data | ) |

virtual

Use this function to feed encrypted data or received handshake data to the encryption implementation. Handshake data will be eaten, unencrypted data will be pushed to the TLSHandler's handleDecryptedData() function.

Parameters

  data | The data to decrypt.

Returns
  The number of bytes used from the input.

Implements TLSBase.

Definition at line 110 of file tlsschannel.cpp.

## encrypt()

bool encrypt | ( | const std::string & | data | ) |

virtual

Use this function to feed unencrypted data to the encryption implementation. The encrypted result will be pushed to the TLSHandler's handleEncryptedData() function.

Parameters

  data | The data to encrypt.

Returns
  Whether or not the data was used successfully.

Implements TLSBase.

Definition at line 34 of file tlsschannel.cpp.

## handshake()

bool handshake | ( |  | ) |

virtual

This functiopn performs the TLS handshake. Handshake data from the server side should be fed in using decrypt(). Handshake data that is to be sent to the other side is pushed through TLSBase's handleEncryptedData().

Returns
  True if the handshake was successful or if more input is needed, false if the handshake failed.

Implements TLSBase.

Definition at line 265 of file tlsschannel.cpp.

## hasChannelBinding()

bool hasChannelBinding | ( |  | ) | const

virtual

This function indicates whether the underlying TLS implementation supports channel binding (used in e.g. SASL SCRAM-SHA-1-PLUS).

Returns
  True if channel binding is supported, false otherwise.

Reimplemented from TLSBase.

Definition at line 481 of file tlsschannel.cpp.

## init()

virtual bool init | ( | const std::string & | clientKey = EmptyString,
|  | const std::string & | clientCerts = EmptyString,
|  | const StringList & | cacerts = StringList() )

inline virtual

Initializes the TLS module. This function must be called (and execute successfully) before the module can be used.

Parameters

  clientKey | The absolute path to the user's private key in PEM format.
  clientCerts | A path to a certificate bundle in PEM format.
  cacerts | A list of absolute paths to CA root certificate files in PEM format.

Returns
  False if initialization failed, true otherwise.

Since
  1.0

Implements TLSBase.

Definition at line 54 of file tlsschannel.h.

## setCACerts()

void setCACerts | ( | const StringList & | cacerts | ) |

virtual

Use this function to set a number of trusted root CA certificates which shall be used to verify a servers certificate.

Parameters

  cacerts | A list of absolute paths to CA root certificate files in PEM format.

Implements TLSBase.

Definition at line 502 of file tlsschannel.cpp.

## setClientCert()

void setClientCert | ( | const std::string & | clientKey,
|  | const std::string & | clientCerts )

virtual

Use this function to set the user's certificate and private key. The certificate will be presented to the server upon request and can be used for SASL EXTERNAL authentication. The user's certificate file should be a bundle of more than one certificate in PEM format. The first one in the file should be the user's certificate, each cert following that one should have signed the previous one.

Note
  These certificates are not necessarily the same as those used to verify the server's certificate.

Parameters

  clientKey | The absolute path to the user's private key in PEM format.
  clientCerts | A path to a certificate bundle in PEM format.

Implements TLSBase.

Definition at line 504 of file tlsschannel.cpp.

The documentation for this class was generated from the following files:

- tlsschannel.h
- tlsschannel.cpp